﻿
const mergeEntities = <T extends object,TK extends keyof T>
    (oldMap: T, newMap: Partial<T>)
    : T => {
    const keys = Object.keys(newMap) as TK[];
    let merged: any = {};
    for (let i = 0, l = keys.length; i < l; ++i) {
        const entityName = keys[i];
        merged[entityName] = {
            ...(oldMap[entityName] as any || {}),
            ...(newMap[entityName] as any)
        };
    }
    return {
        ...(oldMap as any),
        ...merged
    };
};

export default mergeEntities;